#include "precompile.h"

#include "buff/bufffactory.h"

#include "buff.h"

#include "buff/add_car.h"
#include "buff/add_inventory.h"
#include "buff/autoshot.h"
#include "buff/batch_add.h"
#include "buff/beatback.h"
#include "buff/berecycle.h"
#include "buff/callfunc.h"
#include "buff/camouflage.h"
#include "buff/camouflage_addition.h"
#include "buff/event_add.h"
#include "buff/delay_add.h"
#include "buff/disperse.h"
#include "buff/dive.h"
#include "buff/driver.h"
#include "buff/flashmove.h"
#include "buff/hide.h"
#include "buff/hold_shield.h"
#include "buff/immune.h"
#include "buff/in_water.h"
#include "buff/internal_add.h"
#include "buff/jump.h"
#include "buff/machine_gun.h"
#include "buff/once_chg_attr.h"
#include "buff/passenger.h"
#include "buff/pull.h"
#include "buff/pull_to_walkable.h"
#include "buff/remove_car.h"
#include "buff/rescuer.h"
#include "buff/reverse.h"
#include "buff/select_target_with_self_pos.h"
#include "buff/select_target_with_spec_pos.h"
#include "buff/sprint.h"
#include "buff/summon_loot.h"
#include "buff/summon_obstacle.h"
#include "buff/turnover.h"
#include "buff/use_skill.h"
#include "buff/invincible.h"
#include "buff/modify_attr.h"
#include "buff/modify_base_attr.h"
#include "buff/modify_grow_attr.h"
#include "buff/direct_set_attr.h"
#include "buff/vertigo.h"
#include "buff/cond_add.h"
#include "buff/distance_dmg_addition.h"

#include "mt/Buff.h"

std::shared_ptr<Buff> BuffFactory::MakeBuff(const mt::Buff* buff_meta)
{
    switch (buff_meta->buff_effect()) {
    case kBET_ModifyBaseAttr:
        return std::make_shared<ModifyBaseAttrBuff>();
    case kBET_ModifyGrowAttr:
        return std::make_shared<ModifyGrowAttrBuff>();
    case kBET_DirectSetAttr:
        return std::make_shared<DirectSetAttrBuff>();
    case kBET_SummonLoot:
        return std::make_shared<SummonLootBuff>();
    case kBET_DistanceDmgAddition:
        return std::make_shared<DistanceDmgAdditionBuff>();
    case kBET_AddCarBuff:
        return std::make_shared<AddCarBuff>();
    case kBET_AddInventory:
        return std::make_shared<AddInventoryBuff>();
    case kBET_AutoShot:
        return std::make_shared<AutoShotBuff>();
    case kBET_BatchAddBuff:
        return std::make_shared<BatchAddBuff>();
    case kBET_BeatBack:
        return std::make_shared<BeatBackBuff>();
    case kBET_BeRecycle:
        return std::make_shared<BeRecycleBuff>();
    case kBET_CallFunc:
        return std::make_shared<CallFuncBuff>();
    case kBET_Camouflage:
        return std::make_shared<CamouflageBuff>();
    case kBET_CamouflageAddition:
        return std::make_shared<CamouflageAdditionBuff>();
    case kBET_EventAdd:
        return std::make_shared<EventAddBuff>();
    case kBET_DelayAddBuff:
        return std::make_shared<DelayAddBuff>();
    case kBET_Disperse:
        return std::make_shared<DisperseBuff>();
    case kBET_Dive:
        return std::make_shared<DiveBuff>();
    case kBET_Driver:
        return std::make_shared<DriverBuff>();
    case kBET_FlashMove:
        return std::make_shared<FlashMoveBuff>();
    case kBET_Hide:
        return std::make_shared<HideBuff>();
    case kBET_HoldShield:
        return std::make_shared<HoldShieldBuff>();
    case kBET_Immune:
        return std::make_shared<ImmuneBuff>();
    case kBET_InWater:
        return std::make_shared<InWaterBuff>();
    case kBET_IntervalAddBuff:
        return std::make_shared<InternalAddBuff>();
    case kBET_Jump:
        return std::make_shared<JumpBuff>();
    case kBET_MachineGun:
        return std::make_shared<MachineGunBuff>();
    case kBET_OnceChgAttr:
        return std::make_shared<OnceChgAttrBuff>();
    case kBET_Passenger:
        return std::make_shared<PassengerBuff>();
    case kBET_PullToWalkable:
        return std::make_shared<PullToWalkableBuff>();
    case kBET_RemoveCarBuff:
        return std::make_shared<RemoveCarBuff>();
    case kBET_Rescuer:
        return std::make_shared<RescuerBuff>();
    case kBET_Reverse:
        return std::make_shared<ReverseBuff>();
    case kBET_SelectTargetWithSelfPos:
        return std::make_shared<SelectTargetWithSelfPosBuff>();
    case kBET_SelectTargetWithSpecPos:
        return std::make_shared<SelectTargetWithSpecPosBuff>();
    case kBET_Sprint:
        return std::make_shared<SprintBuff>();
    case kBET_SummonObstacle:
        return std::make_shared<SummonObstacleBuff>();
    case kBET_TurnOver:
        return std::make_shared<TurnOverBuff>();
    case kBET_UseSkill:
        return std::make_shared<UseSkillBuff>();
    case kBET_Invincible:
        return std::make_shared<InvincibleBuff>();
    case kBET_ModifyAttr:
        return std::make_shared<ModifyBuff>();
    case kBET_Vertigo:
        return std::make_shared<VertigoBuff>();
    case kBET_CondAdd:
        return std::make_shared<CondAddBuff>();
    default:
        return std::make_shared<Buff>();
    }
}
