#pragma once

class Room;
class CustomTeam;
class CustomMember;
class CustomBattle
{
 public:

    void Init();
    void UnInit();

    bool GetParseOk() { return parse_ok_; }
    Room* GetRoom() { return room_; }
    void SetRoom(Room* room) { room_ = room; }
    const std::string& GetRoomId() { return room_id_; }
    const std::string& GetRoomUuid() { return room_uuid_; }
    const std::string& GetSign() { return sign_; }
    const std::shared_ptr<a8::XObject>& GetRawData() { return raw_data_; }
    int GetZoneId() { return zone_id_; }
    int GetNodeId() { return zone_id_; }
    int GetStartTime() { return start_time_; }
    void ParseResult(a8::XObject& obj);
    bool CanAdd(const std::string& account_id, const std::string& session_id);
    std::shared_ptr<CustomTeam> GetTeamByAccountId(const std::string& account_id);
    std::shared_ptr<CustomMember> GetMemberByAccountId(const std::string& account_id);
    std::shared_ptr<CustomTeam> GetTeamByTeamUuid(const std::string& team_uuid);
    bool AllIsJoined();
    int GetMemberNum();
    void TraverseMemberList(std::function<bool (CustomMember*)> func);

 private:
    bool parse_ok_ = false;
    Room *room_ = nullptr;
    std::string room_id_;
    std::string room_uuid_;
    int zone_id_ = 0;
    int node_id_ = 0;
    int start_time_ = 0;
    std::string sign_;
    std::shared_ptr<a8::XObject> raw_data_;
    std::map<std::string, std::shared_ptr<CustomTeam>> uuid_hash_;
    std::map<std::string, std::shared_ptr<CustomTeam>> account_hash_;
    std::map<std::string, std::shared_ptr<CustomMember>> member_id_hash_;
};
