#pragma once

#include "DetourNavMeshQuery.h"

struct MovePathPoint
{
private:
    Position src_pos;
    Position tar_pos;
    Position curr_pos;
    glm::vec3 dir;
    float distance = 0.0f;
    int same_polys_flags = 0;
    std::vector<dtPolyRef> spec_polys;

    friend class Movement;
};

class Creature;
class Movement
{
 public:
    Movement(Creature* owner);

    bool UpdatePosition();
    void CalcTargetPos(float distance);
    void ClearPath();
    size_t GetPathSize();
    bool IsFindPath() { return is_find_path_; }
    bool FindPath(const glm::vec3& target_pos, float distance);

private:
    void AdjustLastPath(float distance);

 private:
    std::vector<MovePathPoint> paths_;
    int path_index_ = 0;
    Creature* owner_ = nullptr;
    bool is_find_path_ = false;
};
