#pragma once

#include <bitset>

namespace mtb
{

  class Grasp
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int grasp_id() const { return grasp_id_; };
    int hero_id() const { return hero_id_; };
    int hero_lv() const { return hero_lv_; };
    int graspbuff_id1() const { return graspbuff_id1_; };
    int graspbuff_id1_floor2() const { return graspbuff_id1_floor2_; };
    int graspbuff_id2() const { return graspbuff_id2_; };
    int weapon_id() const { return weapon_id_; };
    const std::string add_buff_list() const { return add_buff_list_; };
    const std::string remove_buff_list() const { return remove_buff_list_; };

    bool has_grasp_id() const { return __flags__.test(0);};
    bool has_hero_id() const { return __flags__.test(1);};
    bool has_hero_lv() const { return __flags__.test(2);};
    bool has_graspbuff_id1() const { return __flags__.test(3);};
    bool has_graspbuff_id1_floor2() const { return __flags__.test(4);};
    bool has_graspbuff_id2() const { return __flags__.test(5);};
    bool has_weapon_id() const { return __flags__.test(6);};
    bool has_add_buff_list() const { return __flags__.test(7);};
    bool has_remove_buff_list() const { return __flags__.test(8);};

  protected:

    int grasp_id_ = 0;
    int hero_id_ = 0;
    int hero_lv_ = 0;
    int graspbuff_id1_ = 0;
    int graspbuff_id1_floor2_ = 0;
    int graspbuff_id2_ = 0;
    int weapon_id_ = 0;
    std::string add_buff_list_;
    std::string remove_buff_list_;

public:
    std::bitset<9> __flags__;
  };

};
