#pragma once

#include <bitset>

namespace mtb
{

  class GraspBuff
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int graspbuff_id() const { return graspbuff_id_; };
    int graspbuff_floor() const { return graspbuff_floor_; };
    const std::string graspbuff_trigger() const { return graspbuff_trigger_; };
    int graspbuff_target() const { return graspbuff_target_; };
    const std::string graspbuff_time() const { return graspbuff_time_; };
    int attr_id() const { return attr_id_; };
    int attr_add_pattern() const { return attr_add_pattern_; };
    int attr_add_pattern2() const { return attr_add_pattern2_; };
    const std::string attr_num() const { return attr_num_; };
    const std::string effect_list() const { return effect_list_; };

    bool has_graspbuff_id() const { return __flags__.test(0);};
    bool has_graspbuff_floor() const { return __flags__.test(1);};
    bool has_graspbuff_trigger() const { return __flags__.test(2);};
    bool has_graspbuff_target() const { return __flags__.test(3);};
    bool has_graspbuff_time() const { return __flags__.test(4);};
    bool has_attr_id() const { return __flags__.test(5);};
    bool has_attr_add_pattern() const { return __flags__.test(6);};
    bool has_attr_add_pattern2() const { return __flags__.test(7);};
    bool has_attr_num() const { return __flags__.test(8);};
    bool has_effect_list() const { return __flags__.test(9);};

  protected:

    int graspbuff_id_ = 0;
    int graspbuff_floor_ = 0;
    std::string graspbuff_trigger_;
    int graspbuff_target_ = 0;
    std::string graspbuff_time_;
    int attr_id_ = 0;
    int attr_add_pattern_ = 0;
    int attr_add_pattern2_ = 0;
    std::string attr_num_;
    std::string effect_list_;

public:
    std::bitset<10> __flags__;
  };

};
